//--------------------------------------------------------------------------------------
// Order Independent Transparency Vertex Shader
//
// Author: Louis Bavoil
// Email: sdkfeedback@nvidia.com
//
// Copyright (c) NVIDIA Corporation. All rights reserved.
//--------------------------------------------------------------------------------------

varying vec3 jpNormal;
varying vec3 jpWorld;
varying vec3 jpObject;
varying vec2 jpTexCoord;
varying vec4 vertColor;

vec3 ShadeVertex()
{
	jpNormal = normalize(gl_NormalMatrix * gl_Normal);
	jpWorld = vec3(gl_ModelViewMatrix * gl_Vertex);
	//jpPosition = vec3(gl_ModelViewMatrix * gl_Vertex);
	float diffuse = abs(normalize(gl_NormalMatrix * gl_Normal).z);
	jpObject = vec3(gl_Vertex);
    
  	jpTexCoord = sign(gl_Vertex.xy) * 0.5 + 0.5;

	vertColor = gl_Color;

	return vec3(gl_Vertex.xy, diffuse);
}
